       subroutine Verline(p1,p2,p3,barpsi_p3,psi_p1,mup2,alpha,musq,co
     &   mp,result,resultb,Div)
c ************************************************************************************
c ************************************************************************************
c Author: Francisco Campanario
c E-mail: francam@particle.uni-karlsruhe.de
c Date: 18/08/2009
c Modified:3/4/2012
c ************************************************************************************
c determine wave renormalization functions for the boxline
c psi(p1)    ---->------->------->------->---   bar_psi(p3)
c                          $         $                   
c                          $         $                   
c                          $         $                  
c                          V         V                  
c                          $         $                  
c                          $         $                  
c                          p2        p3                  
c                        mu_p2      mu_p3           
c Note: The vertices are just Gamma^(mu_p2)..terms. So the correct
c factor should be added by hand for each boson. i.e, Without adding
c anything it represents pp->gluon+2 photons up to the electromagnetic charge 
c (for uu->g+2 photons is missing (2/3)) from the coupling. For W and Z,
c we have to account for the Diracgamma_5 that are missing in the vertex
c Note: To make it shorter in the promgram: mu_p2,...->mup2,... 
c Notation of External momenta: p1+p2+p3+p4=0 
c mu_p2,mu_p3, should be think as external current 
c alpha is the helicity of the initial spinor 
c musq is the renormalization scale energy  
c************************************************************************************
c    Declaration of variables 
c************************************************************************************
c************************************************************************************
c************************************************************************************
       IMPLICIT NONE
      Real*8   p1(0:3),p2(0:3),p3(0:3)
       Complex*16 barpsi_p3(2),psi_p1(2),mup2(0:3)
       Real*8   p1sq, p1p2, p1p3, p2sq, p2p3, p3sq
       Real*8   s12
       Complex*16   p1mup2, p2mup2, p3mup2
       Real*8 dotrr
       Complex*16 B0fin,C0fin
       complex*16 B0finDiv,C0finDiv
       EXTERNAL dotrr,B0fin,C0fin,B0finDiv,C0finDiv
       Complex*16 B012,B013,B023,C0123
      Real*8 B012R,B013R,B023R,C0123R,C123R(4,2)
      Real*8 B012I,B013I,B023I,C0123I,C123I(4,2)
      Complex*16 SMB(2),SMG(2) ,F(5)
      Real*8 FI(5),FR(5) 
      Complex*16 SC1r,SC1c,SC3rcc,dotrc,dotcc,result,resultb
       Real*8 musq,P(1) 
       EXTERNAL   dotrc,dotcc,SC1c,SC1r,SC3rcc
       Integer alpha,comp,nf
      Real*8 CA,TF
c************************************************************************************
c************************************************************************************
       common/FfunctionsVertline/F
       common/PfunctionsVertline/P
       SAVE/FfunctionsVertline/
       SAVE/PfunctionsVertline/
       integer i,Div
c       Definition of the scalar products. Not inlcueded the contraction of the
c       moments with the external currents  
c************************************************************************************
c************************************************************************************
c************************************************************************************
       p1sq = dotrr(p1,p1)
       p1p2 = dotrr(p1,p2)
       p1p3 = dotrr(p1,p3)
       p2sq = dotrr(p2,p2)
       p2p3 = dotrr(p2,p3)
       p3sq = dotrr(p3,p3)
       s12 = (p1sq +p2sq+ 2*p1p2) 
c       print*,"here",(p1(i)+p2(i)+p3(i),i=0,3)
c       print*, "scale", musq
c       print*, "p2sq",p2sq
c************************************************************************************
c************************************************************************************
c************************************************************************************
        if (comp.gt.0) then    
c    Calling C_ij,D_ij Functions    
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
           if(div.eq.0) then
       B012=B0fin(p1sq,musq)  
       B012R=Dble(B012)  
       B012I=DIMAG(B012)  
       B013=B0fin(s12,musq)  
       B013R=Dble(B013)  
       B013I=DIMAG(B013)  
       B023=B0fin(p2sq,musq)  
       B023R=Dble(B023)  
       B023I=DIMAG(B023)  
       C0123=C0fin(p1sq,p2sq,s12,musq)  
       call tens_red3_new_Re_Com(p1sq,p2sq,s12,B023,B013,B012,C0123,C0
     &   123R,C0123I,C123R,C123I) 
       else
       B012=B0finDiv(p1sq,musq,Div)  
       B012R=Dble(B012)  
       B012I=DIMAG(B012)  
       B013=B0finDiv(s12,musq,Div)  
       B013R=Dble(B013)  
       B013I=DIMAG(B013)  
       B023=B0finDiv(p2sq,musq,Div)  
       B023R=Dble(B023)  
       B023I=DIMAG(B023)  
       C0123=C0finDiv(p1sq,p2sq,s12,musq,Div)  
       call tens_red3_new_Re_Com_Div(p1sq,p2sq,s12,B023,B013,B012,C0123,C0
     &   123R,C0123I,C123R,C123I) 

      endif

c************************************************************************************
c************************************************************************************
c************************************************************************************
c       Definition of the F,P functions:Independent of the currents    
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
       P(1) = p2sq-s12
       FR(1) = 2*(B013R+p2sq*C123R(2,1)-2*C123R(4,2)-(C0123R+C123R(1,1
     &   ))*P(1))
       FI(1) = 2*(B013I+p2sq*C123I(2,1)-2*C123I(4,2)-(C0123I+C123I(1,1
     &   ))*P(1))
       F(1)=DCMPLX(FR(1),FI(1))
       FR(2) = C0123R+C123R(1,1)+C123R(2,1)+C123R(3,2)
       FI(2) = C0123I+C123I(1,1)+C123I(2,1)+C123I(3,2)
       F(2)=DCMPLX(FR(2),FI(2))
       FR(3) = C123R(2,1)+C123R(2,2)
       FI(3) = C123I(2,1)+C123I(2,2)
       F(3)=DCMPLX(FR(3),FI(3))
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
       endif  
c               PART THAT DEPENDS ON THE EXTERNAL CURRENT
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c Computation of Fa fucntions. Depends on the external currents, through
c the contraction of the moments with the currents
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
       p1mup2 = dotrc(p1,mup2)
       p2mup2 = dotrc(p2,mup2)
       p3mup2 = dotrc(p3,mup2)
c************************************************************************************
c************************************************************************************
c       Definition of the Matrix Element  
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
       SMB(1) = SC1c(barpsi_p3,mup2,psi_p1,alpha)
       SMB(2) = SC1r(barpsi_p3,p2,psi_p1,alpha)
c       Print*," SMB(1) ", SMB(1)
c       Print*," SMB(2) ", SMB(2)
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c       Amplitude                         
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************


       result = F(1)*SMB(1)-4*(p1mup2*F(2)+p2mup2*F(3))*SMB(2)
c The Finite virtual piece should be multiplied for (-1)  since 
c I have multiplied by (-I) to get the F's and k's without (I) factor
c . The factorization from the B_ij is Fact=(I/(4\[Pi])^2 (4 \[Pi])^Eps Gamma[1+Eps] (musq)^(-Eps))
c  c So, I*I=(-1)!!!
       result =-result
       resultb = -SMB(1)

       If(Div.eq.0) then
          result=result-resultb
        endif
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
c************************************************************************************
       Return
       End
